#!/usr/bin/perl

#*____________________________________________________________________________*\
#*
#
# Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.
#
# These sources, libraries and applications are
# FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
# as long as the following conditions are adhered to.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. Redistributions of any form whatsoever and all advertising materials 
#    mentioning features must contain the following
#    acknowledgment:
#    "This product includes software developed by John Roy
#    and Holger Zimmermann (http://pi3web.sourceforge.net/)."
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
# GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
#*____________________________________________________________________________*|
#*
#* $Source: /cvsroot/pi3web/Pi3Web_200/Source/Pi3Perl/Pi3PAPI/2xsh.pl,v $
#* $Date: 2001/09/04 19:58:34 $
#*
# Description:
#   Convert text files to windows format.
#
# Parameters
#*____________________________________________________________________________*/

&do_main( @ARGV );

#/*___________________________________________________________________________*\
# *
# Function:
# Synopsis:
# Description:
#\*___________________________________________________________________________*/
sub do_main
	{
	if ( $^O =~ /MSWin32/ )
		{
		local( @args );
		foreach( @_ ) { push @args, glob; };
		@_=@args;
		};
	foreach( @_ )
		{
		print "2xsh.pl: Scanning $_...\n";
		open( INP, '<'.$_ ) || die "Cannot open file $_ $!\n";
		$current_file = $_;
		&write_file( $_ );
		close( INP );

        # 
        # rename files
        #
        $_ = $current_file;
        rename $_.'_', $_ || die "Cannot rename $_".'_'." to $_ $!\n";
		};
	};

#/*___________________________________________________________________________*\
# *
# Function:
# Synopsis:
# Description:
#\*___________________________________________________________________________*/
sub write_file
{
	local( $file ) = @_;
	$_ = $file.'_';
	open( OUT, '>'.$_ ) || die "Cannot open file $_ $!\n";
	while( <INP> ) {
		$_ =~ s/const char \*/char \*/g && print "Applied rule 01 ... $_";
		$_ =~ s/char \*ppArgv\[\]/char \*\*ppArgv/g && print "Applied rule 02 ... $_";
		$_ =~ s/void \*\(\* fnLookup\)\( PIDB \*\, int\, char \*\, int \)/void \*fnLookup/ && print "Applied rule 03 ... $_";
		$_ =~ s/int \(\* fnParameters\)\( void \*\, char \*\, char \*\, char \*\)/int \*fnParameters/ && print "Applied rule 04 ... $_";
		$_ =~ s/PIObject \*\(\* nextHandler\)\(\void \*\)/PIObject \*nextHandler/ && print "Applied rule 05 ... $_";
		
		if (/PUBLIC_PIAPI void \*PIDBIterator_current/) {
			print OUT <<END;
#ifdef H2XS
PUBLIC_PIAPI void *PIDBIterator_current( PIDBIterator *pIter,
	int iType, char *pKey );
#else
PUBLIC_PIAPI void *PIDBIterator_current( PIDBIterator *pIter,
	char **ppKey );
#endif
END
			readline(*INP);
			print "Applied rule 06 ... $_ in $file\n";
		} else {
			print OUT $_;
		};
	};
	close( OUT );
};

