#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include </home/holger/work/Pi3Web_200_r/Source/Pi3Perl/Pi3PAPI/HTTPDefs.h>
#include </home/holger/work/Pi3Web_200_r/Source/Pi3Perl/Pi3PAPI/PIDefs.h>
#include </home/holger/work/Pi3Web_200_r/Source/Pi3Perl/Pi3PAPI/Pi3PAPI.h>

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant_GETDB_R(char *name, int len, int arg)
{
    if (7 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[7 + 1]) {
    case 'Q':
	if (strEQ(name + 7, "EQUEST")) {	/* GETDB_R removed */
#ifdef GETDB_REQUEST
	    return GETDB_REQUEST;
#else
	    goto not_there;
#endif
	}
    case 'S':
	if (strEQ(name + 7, "ESPONSE")) {	/* GETDB_R removed */
#ifdef GETDB_RESPONSE
	    return GETDB_RESPONSE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_G(char *name, int len, int arg)
{
    if (1 + 5 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[1 + 5]) {
    case 'C':
	if (strEQ(name + 1, "ETDB_CONNECTION")) {	/* G removed */
#ifdef GETDB_CONNECTION
	    return GETDB_CONNECTION;
#else
	    goto not_there;
#endif
	}
    case 'H':
	if (strEQ(name + 1, "ETDB_HOST")) {	/* G removed */
#ifdef GETDB_HOST
	    return GETDB_HOST;
#else
	    goto not_there;
#endif
	}
    case 'R':
	if (!strnEQ(name + 1,"ETDB_", 5))
	    break;
	return constant_GETDB_R(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PH_H(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'A':
	if (strEQ(name + 4, "ANDLE")) {	/* PH_H removed */
#ifdef PH_HANDLE
	    return PH_HANDLE;
#else
	    goto not_there;
#endif
	}
    case 'E':
	if (strEQ(name + 4, "EADERS")) {	/* PH_H removed */
#ifdef PH_HEADERS
	    return PH_HEADERS;
#else
	    goto not_there;
#endif
	}
    case 'O':
	if (strEQ(name + 4, "OSTMAP")) {	/* PH_H removed */
#ifdef PH_HOSTMAP
	    return PH_HOSTMAP;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PH_I(char *name, int len, int arg)
{
    if (4 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[4 + 1]) {
    case 'I':
	if (strEQ(name + 4, "NIT")) {	/* PH_I removed */
#ifdef PH_INIT
	    return PH_INIT;
#else
	    goto not_there;
#endif
	}
    case 'V':
	if (strEQ(name + 4, "NVALID")) {	/* PH_I removed */
#ifdef PH_INVALID
	    return PH_INVALID;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PH_CHECKA(char *name, int len, int arg)
{
    switch (name[9 + 0]) {
    case 'C':
	if (strEQ(name + 9, "CCESS")) {	/* PH_CHECKA removed */
#ifdef PH_CHECKACCESS
	    return PH_CHECKACCESS;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 9, "UTH")) {	/* PH_CHECKA removed */
#ifdef PH_CHECKAUTH
	    return PH_CHECKAUTH;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PH_C(char *name, int len, int arg)
{
    if (4 + 4 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[4 + 4]) {
    case 'A':
	if (!strnEQ(name + 4,"HECK", 4))
	    break;
	return constant_PH_CHECKA(name, len, arg);
    case 'P':
	if (strEQ(name + 4, "HECKPATH")) {	/* PH_C removed */
#ifdef PH_CHECKPATH
	    return PH_CHECKPATH;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (strEQ(name + 4, "HECKTYPE")) {	/* PH_C removed */
#ifdef PH_CHECKTYPE
	    return PH_CHECKTYPE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PH(char *name, int len, int arg)
{
    if (2 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[2 + 1]) {
    case 'C':
	if (!strnEQ(name + 2,"_", 1))
	    break;
	return constant_PH_C(name, len, arg);
    case 'D':
	if (strEQ(name + 2, "_DESTROY")) {	/* PH removed */
#ifdef PH_DESTROY
	    return PH_DESTROY;
#else
	    goto not_there;
#endif
	}
    case 'H':
	if (!strnEQ(name + 2,"_", 1))
	    break;
	return constant_PH_H(name, len, arg);
    case 'I':
	if (!strnEQ(name + 2,"_", 1))
	    break;
	return constant_PH_I(name, len, arg);
    case 'L':
	if (strEQ(name + 2, "_LOG")) {	/* PH removed */
#ifdef PH_LOG
	    return PH_LOG;
#else
	    goto not_there;
#endif
	}
    case 'M':
	if (strEQ(name + 2, "_MAPPING")) {	/* PH removed */
#ifdef PH_MAPPING
	    return PH_MAPPING;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (strEQ(name + 2, "_NUMBER")) {	/* PH removed */
#ifdef PH_NUMBER
	    return PH_NUMBER;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIIOBUF_N(char *name, int len, int arg)
{
    if (9 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[9 + 1]) {
    case 'B':
	if (strEQ(name + 9, "OBUFFER")) {	/* PIIOBUF_N removed */
#ifdef PIIOBUF_NOBUFFER
	    return PIIOBUF_NOBUFFER;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (strEQ(name + 9, "ONE")) {	/* PIIOBUF_N removed */
#ifdef PIIOBUF_NONE
	    return PIIOBUF_NONE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PII(char *name, int len, int arg)
{
    if (3 + 5 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[3 + 5]) {
    case 'C':
	if (strEQ(name + 3, "OBUF_CHUNKED")) {	/* PII removed */
#ifdef PIIOBUF_CHUNKED
	    return PIIOBUF_CHUNKED;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (!strnEQ(name + 3,"OBUF_", 5))
	    break;
	return constant_PIIOBUF_N(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIAPI_C(char *name, int len, int arg)
{
    if (7 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[7 + 1]) {
    case 'M':
	if (strEQ(name + 7, "OMPLETED")) {	/* PIAPI_C removed */
#ifdef PIAPI_COMPLETED
	    return PIAPI_COMPLETED;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (strEQ(name + 7, "ONTINUE")) {	/* PIAPI_C removed */
#ifdef PIAPI_CONTINUE
	    return PIAPI_CONTINUE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIAPI_T(char *name, int len, int arg)
{
    switch (name[7 + 0]) {
    case 'I':
	if (strEQ(name + 7, "IMEOUT")) {	/* PIAPI_T removed */
#ifdef PIAPI_TIMEOUT
	    return PIAPI_TIMEOUT;
#else
	    goto not_there;
#endif
	}
    case 'R':
	if (strEQ(name + 7, "RUE")) {	/* PIAPI_T removed */
#ifdef PIAPI_TRUE
	    return PIAPI_TRUE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIAPI_EI(char *name, int len, int arg)
{
    if (8 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[8 + 1]) {
    case 'I':
	if (strEQ(name + 8, "NIT")) {	/* PIAPI_EI removed */
#ifdef PIAPI_EINIT
	    return PIAPI_EINIT;
#else
	    goto not_there;
#endif
	}
    case 'V':
	if (strEQ(name + 8, "NVAL")) {	/* PIAPI_EI removed */
#ifdef PIAPI_EINVAL
	    return PIAPI_EINVAL;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIAPI_E(char *name, int len, int arg)
{
    switch (name[7 + 0]) {
    case 'A':
	if (strEQ(name + 7, "ACCES")) {	/* PIAPI_E removed */
#ifdef PIAPI_EACCES
	    return PIAPI_EACCES;
#else
	    goto not_there;
#endif
	}
    case 'E':
	if (strEQ(name + 7, "EXIST")) {	/* PIAPI_E removed */
#ifdef PIAPI_EEXIST
	    return PIAPI_EEXIST;
#else
	    goto not_there;
#endif
	}
    case 'I':
	return constant_PIAPI_EI(name, len, arg);
    case 'R':
	if (strEQ(name + 7, "RROR")) {	/* PIAPI_E removed */
#ifdef PIAPI_ERROR
	    return PIAPI_ERROR;
#else
	    goto not_there;
#endif
	}
    case 'X':
	if (strEQ(name + 7, "XHAUSTED")) {	/* PIAPI_E removed */
#ifdef PIAPI_EXHAUSTED
	    return PIAPI_EXHAUSTED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIAPI_W(char *name, int len, int arg)
{
    switch (name[7 + 0]) {
    case 'A':
	if (strEQ(name + 7, "ARNING")) {	/* PIAPI_W removed */
#ifdef PIAPI_WARNING
	    return PIAPI_WARNING;
#else
	    goto not_there;
#endif
	}
    case 'O':
	if (strEQ(name + 7, "OULDBLOCK")) {	/* PIAPI_W removed */
#ifdef PIAPI_WOULDBLOCK
	    return PIAPI_WOULDBLOCK;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIA(char *name, int len, int arg)
{
    if (3 + 3 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[3 + 3]) {
    case 'A':
	if (strEQ(name + 3, "PI_ABORT")) {	/* PIA removed */
#ifdef PIAPI_ABORT
	    return PIAPI_ABORT;
#else
	    goto not_there;
#endif
	}
    case 'C':
	if (!strnEQ(name + 3,"PI_", 3))
	    break;
	return constant_PIAPI_C(name, len, arg);
    case 'D':
	if (strEQ(name + 3, "PI_DEADLOCK")) {	/* PIA removed */
#ifdef PIAPI_DEADLOCK
	    return PIAPI_DEADLOCK;
#else
	    goto not_there;
#endif
	}
    case 'E':
	if (!strnEQ(name + 3,"PI_", 3))
	    break;
	return constant_PIAPI_E(name, len, arg);
    case 'F':
	if (strEQ(name + 3, "PI_FALSE")) {	/* PIA removed */
#ifdef PIAPI_FALSE
	    return PIAPI_FALSE;
#else
	    goto not_there;
#endif
	}
    case 'I':
	if (strEQ(name + 3, "PI_INTERNALERROR")) {	/* PIA removed */
#ifdef PIAPI_INTERNALERROR
	    return PIAPI_INTERNALERROR;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (strEQ(name + 3, "PI_NOTSUPPORTED")) {	/* PIA removed */
#ifdef PIAPI_NOTSUPPORTED
	    return PIAPI_NOTSUPPORTED;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (!strnEQ(name + 3,"PI_", 3))
	    break;
	return constant_PIAPI_T(name, len, arg);
    case 'W':
	if (!strnEQ(name + 3,"PI_", 3))
	    break;
	return constant_PIAPI_W(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PITHREAD_PRIORITY_H(char *name, int len, int arg)
{
    if (19 + 3 > len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[19 + 3]) {
    case '\0':
	if (strEQ(name + 19, "IGH")) {	/* PITHREAD_PRIORITY_H removed */
#ifdef PITHREAD_PRIORITY_HIGH
	    return PITHREAD_PRIORITY_HIGH;
#else
	    goto not_there;
#endif
	}
    case 'E':
	if (strEQ(name + 19, "IGHEST")) {	/* PITHREAD_PRIORITY_H removed */
#ifdef PITHREAD_PRIORITY_HIGHEST
	    return PITHREAD_PRIORITY_HIGHEST;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PITHREAD_PRIORITY_L(char *name, int len, int arg)
{
    if (19 + 2 > len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[19 + 2]) {
    case '\0':
	if (strEQ(name + 19, "OW")) {	/* PITHREAD_PRIORITY_L removed */
#ifdef PITHREAD_PRIORITY_LOW
	    return PITHREAD_PRIORITY_LOW;
#else
	    goto not_there;
#endif
	}
    case 'E':
	if (strEQ(name + 19, "OWEST")) {	/* PITHREAD_PRIORITY_L removed */
#ifdef PITHREAD_PRIORITY_LOWEST
	    return PITHREAD_PRIORITY_LOWEST;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PITHREAD_P(char *name, int len, int arg)
{
    if (10 + 8 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[10 + 8]) {
    case 'H':
	if (!strnEQ(name + 10,"RIORITY_", 8))
	    break;
	return constant_PITHREAD_PRIORITY_H(name, len, arg);
    case 'I':
	if (strEQ(name + 10, "RIORITY_INVALID")) {	/* PITHREAD_P removed */
#ifdef PITHREAD_PRIORITY_INVALID
	    return PITHREAD_PRIORITY_INVALID;
#else
	    goto not_there;
#endif
	}
    case 'L':
	if (!strnEQ(name + 10,"RIORITY_", 8))
	    break;
	return constant_PITHREAD_PRIORITY_L(name, len, arg);
    case 'M':
	if (strEQ(name + 10, "RIORITY_MED")) {	/* PITHREAD_P removed */
#ifdef PITHREAD_PRIORITY_MED
	    return PITHREAD_PRIORITY_MED;
#else
	    goto not_there;
#endif
	}
    case 'S':
	if (strEQ(name + 10, "RIORITY_SIZE")) {	/* PITHREAD_P removed */
#ifdef PITHREAD_PRIORITY_SIZE
	    return PITHREAD_PRIORITY_SIZE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIT(char *name, int len, int arg)
{
    if (3 + 6 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[3 + 6]) {
    case 'F':
	if (strEQ(name + 3, "HREAD_FLAGS_SUSPENDED")) {	/* PIT removed */
#ifdef PITHREAD_FLAGS_SUSPENDED
	    return PITHREAD_FLAGS_SUSPENDED;
#else
	    goto not_there;
#endif
	}
    case 'P':
	if (!strnEQ(name + 3,"HREAD_", 6))
	    break;
	return constant_PITHREAD_P(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIDBFLAG_N(char *name, int len, int arg)
{
    if (10 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[10 + 1]) {
    case 'C':
	if (strEQ(name + 10, "OCALLBACK")) {	/* PIDBFLAG_N removed */
#ifdef PIDBFLAG_NOCALLBACK
	    return PIDBFLAG_NOCALLBACK;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (strEQ(name + 10, "ONE")) {	/* PIDBFLAG_N removed */
#ifdef PIDBFLAG_NONE
	    return PIDBFLAG_NONE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIDBF(char *name, int len, int arg)
{
    if (5 + 4 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[5 + 4]) {
    case 'F':
	if (strEQ(name + 5, "LAG_FASTKEY")) {	/* PIDBF removed */
#ifdef PIDBFLAG_FASTKEY
	    return PIDBFLAG_FASTKEY;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (!strnEQ(name + 5,"LAG_", 4))
	    break;
	return constant_PIDBFLAG_N(name, len, arg);
    case 'P':
	if (strEQ(name + 5, "LAG_PROPAGATEUP")) {	/* PIDBF removed */
#ifdef PIDBFLAG_PROPAGATEUP
	    return PIDBFLAG_PROPAGATEUP;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIDBT(char *name, int len, int arg)
{
    if (5 + 4 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[5 + 4]) {
    case 'B':
	if (strEQ(name + 5, "YPE_BUILTINSIZE")) {	/* PIDBT removed */
#ifdef PIDBTYPE_BUILTINSIZE
	    return PIDBTYPE_BUILTINSIZE;
#else
	    goto not_there;
#endif
	}
    case 'I':
	if (strEQ(name + 5, "YPE_INVALID")) {	/* PIDBT removed */
#ifdef PIDBTYPE_INVALID
	    return PIDBTYPE_INVALID;
#else
	    goto not_there;
#endif
	}
    case 'L':
	if (strEQ(name + 5, "YPE_LAST")) {	/* PIDBT removed */
#ifdef PIDBTYPE_LAST
	    return PIDBTYPE_LAST;
#else
	    goto not_there;
#endif
	}
    case 'O':
	if (strEQ(name + 5, "YPE_OPAQUE")) {	/* PIDBT removed */
#ifdef PIDBTYPE_OPAQUE
	    return PIDBTYPE_OPAQUE;
#else
	    goto not_there;
#endif
	}
    case 'R':
	if (strEQ(name + 5, "YPE_RFC822")) {	/* PIDBT removed */
#ifdef PIDBTYPE_RFC822
	    return PIDBTYPE_RFC822;
#else
	    goto not_there;
#endif
	}
    case 'S':
	if (strEQ(name + 5, "YPE_STRING")) {	/* PIDBT removed */
#ifdef PIDBTYPE_STRING
	    return PIDBTYPE_STRING;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (strEQ(name + 5, "YPE_TREE")) {	/* PIDBT removed */
#ifdef PIDBTYPE_TREE
	    return PIDBTYPE_TREE;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 5, "YPE_USER")) {	/* PIDBT removed */
#ifdef PIDBTYPE_USER
	    return PIDBTYPE_USER;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PIDB(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'F':
	return constant_PIDBF(name, len, arg);
    case 'T':
	return constant_PIDBT(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PID(char *name, int len, int arg)
{
    switch (name[3 + 0]) {
    case 'B':
	return constant_PIDB(name, len, arg);
    case 'E':
	if (strEQ(name + 3, "EFS_H_")) {	/* PID removed */
#ifdef PIDEFS_H_
	    return PIDEFS_H_;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PI(char *name, int len, int arg)
{
    switch (name[2 + 0]) {
    case '3':
	if (strEQ(name + 2, "3PAPI_H_")) {	/* PI removed */
#ifdef PI3PAPI_H_
	    return PI3PAPI_H_;
#else
	    goto not_there;
#endif
	}
    case 'A':
	return constant_PIA(name, len, arg);
    case 'D':
	return constant_PID(name, len, arg);
    case 'I':
	return constant_PII(name, len, arg);
    case 'T':
	return constant_PIT(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PR_HTTP1(char *name, int len, int arg)
{
    switch (name[8 + 0]) {
    case '0':
	if (strEQ(name + 8, "0")) {	/* PR_HTTP1 removed */
#ifdef PR_HTTP10
	    return PR_HTTP10;
#else
	    goto not_there;
#endif
	}
    case '1':
	if (strEQ(name + 8, "1")) {	/* PR_HTTP1 removed */
#ifdef PR_HTTP11
	    return PR_HTTP11;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PR_H(char *name, int len, int arg)
{
    if (4 + 3 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[4 + 3]) {
    case '0':
	if (strEQ(name + 4, "TTP09")) {	/* PR_H removed */
#ifdef PR_HTTP09
	    return PR_HTTP09;
#else
	    goto not_there;
#endif
	}
    case '1':
	if (!strnEQ(name + 4,"TTP", 3))
	    break;
	return constant_PR_HTTP1(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_PR(char *name, int len, int arg)
{
    if (2 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[2 + 1]) {
    case 'H':
	if (!strnEQ(name + 2,"_", 1))
	    break;
	return constant_PR_H(name, len, arg);
    case 'U':
	if (strEQ(name + 2, "_UNKNOWN")) {	/* PR removed */
#ifdef PR_UNKNOWN
	    return PR_UNKNOWN;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_P(char *name, int len, int arg)
{
    switch (name[1 + 0]) {
    case 'H':
	return constant_PH(name, len, arg);
    case 'I':
	return constant_PI(name, len, arg);
    case 'R':
	return constant_PR(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_HTTP_D(char *name, int len, int arg)
{
    switch (name[6 + 0]) {
    case 'E':
	if (strEQ(name + 6, "EFAULT_PORT")) {	/* HTTP_D removed */
#ifdef HTTP_DEFAULT_PORT
	    return HTTP_DEFAULT_PORT;
#else
	    goto not_there;
#endif
	}
    case 'I':
	if (strEQ(name + 6, "IRSEPERATOR")) {	/* HTTP_D removed */
#ifdef HTTP_DIRSEPERATOR
	    return HTTP_DIRSEPERATOR;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_HTTP_(char *name, int len, int arg)
{
    switch (name[5 + 0]) {
    case 'C':
	if (strEQ(name + 5, "CR")) {	/* HTTP_ removed */
#ifdef HTTP_CR
	    return HTTP_CR;
#else
	    goto not_there;
#endif
	}
    case 'D':
	return constant_HTTP_D(name, len, arg);
    case 'L':
	if (strEQ(name + 5, "LF")) {	/* HTTP_ removed */
#ifdef HTTP_LF
	    return HTTP_LF;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_H(char *name, int len, int arg)
{
    if (1 + 3 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[1 + 3]) {
    case 'D':
	if (strEQ(name + 1, "TTPDEFS_H_")) {	/* H removed */
#ifdef HTTPDEFS_H_
	    return HTTPDEFS_H_;
#else
	    goto not_there;
#endif
	}
    case 'S':
	if (strEQ(name + 1, "TTPS_DEFAULT_PORT")) {	/* H removed */
#ifdef HTTPS_DEFAULT_PORT
	    return HTTPS_DEFAULT_PORT;
#else
	    goto not_there;
#endif
	}
    case '_':
	if (!strnEQ(name + 1,"TTP", 3))
	    break;
	return constant_HTTP_(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_I(char *name, int len, int arg)
{
    if (1 + 3 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[1 + 3]) {
    case 'C':
	if (strEQ(name + 1, "NT_CONTINUE")) {	/* I removed */
#ifdef INT_CONTINUE
	    return INT_CONTINUE;
#else
	    goto not_there;
#endif
	}
    case 'R':
	if (strEQ(name + 1, "NT_REDIRECT")) {	/* I removed */
#ifdef INT_REDIRECT
	    return INT_REDIRECT;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_NOT(char *name, int len, int arg)
{
    switch (name[6 + 0]) {
    case 'A':
	if (strEQ(name + 6, "ACCEPTABLE")) {	/* ST_NOT removed */
#ifdef ST_NOTACCEPTABLE
	    return ST_NOTACCEPTABLE;
#else
	    goto not_there;
#endif
	}
    case 'F':
	if (strEQ(name + 6, "FOUND")) {	/* ST_NOT removed */
#ifdef ST_NOTFOUND
	    return ST_NOTFOUND;
#else
	    goto not_there;
#endif
	}
    case 'I':
	if (strEQ(name + 6, "IMPLEMENTED")) {	/* ST_NOT removed */
#ifdef ST_NOTIMPLEMENTED
	    return ST_NOTIMPLEMENTED;
#else
	    goto not_there;
#endif
	}
    case 'M':
	if (strEQ(name + 6, "MODIFIED")) {	/* ST_NOT removed */
#ifdef ST_NOTMODIFIED
	    return ST_NOTMODIFIED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_N(char *name, int len, int arg)
{
    if (4 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[4 + 1]) {
    case 'C':
	if (strEQ(name + 4, "OCONTENT")) {	/* ST_N removed */
#ifdef ST_NOCONTENT
	    return ST_NOCONTENT;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (strEQ(name + 4, "ONAUTHORITATIVEINFO")) {	/* ST_N removed */
#ifdef ST_NONAUTHORITATIVEINFO
	    return ST_NONAUTHORITATIVEINFO;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (!strnEQ(name + 4,"O", 1))
	    break;
	return constant_ST_NOT(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_PA(char *name, int len, int arg)
{
    switch (name[5 + 0]) {
    case 'R':
	if (strEQ(name + 5, "RTIALCONTENT")) {	/* ST_PA removed */
#ifdef ST_PARTIALCONTENT
	    return ST_PARTIALCONTENT;
#else
	    goto not_there;
#endif
	}
    case 'Y':
	if (strEQ(name + 5, "YMENTREQUIRED")) {	/* ST_PA removed */
#ifdef ST_PAYMENTREQUIRED
	    return ST_PAYMENTREQUIRED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_PR(char *name, int len, int arg)
{
    switch (name[5 + 0]) {
    case 'E':
	if (strEQ(name + 5, "ECONDITIONFAILED")) {	/* ST_PR removed */
#ifdef ST_PRECONDITIONFAILED
	    return ST_PRECONDITIONFAILED;
#else
	    goto not_there;
#endif
	}
    case 'O':
	if (strEQ(name + 5, "OXYAUTHREQUIRED")) {	/* ST_PR removed */
#ifdef ST_PROXYAUTHREQUIRED
	    return ST_PROXYAUTHREQUIRED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_P(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'A':
	return constant_ST_PA(name, len, arg);
    case 'E':
	if (strEQ(name + 4, "ERMANENTREDIRECT")) {	/* ST_P removed */
#ifdef ST_PERMANENTREDIRECT
	    return ST_PERMANENTREDIRECT;
#else
	    goto not_there;
#endif
	}
    case 'R':
	return constant_ST_PR(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_REQ(char *name, int len, int arg)
{
    if (6 + 4 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[6 + 4]) {
    case 'E':
	if (strEQ(name + 6, "UESTENTITYTOOLARGE")) {	/* ST_REQ removed */
#ifdef ST_REQUESTENTITYTOOLARGE
	    return ST_REQUESTENTITYTOOLARGE;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (strEQ(name + 6, "UESTTIMEOUT")) {	/* ST_REQ removed */
#ifdef ST_REQUESTTIMEOUT
	    return ST_REQUESTTIMEOUT;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 6, "UESTURITOOLONG")) {	/* ST_REQ removed */
#ifdef ST_REQUESTURITOOLONG
	    return ST_REQUESTURITOOLONG;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_RE(char *name, int len, int arg)
{
    switch (name[5 + 0]) {
    case 'Q':
	return constant_ST_REQ(name, len, arg);
    case 'S':
	if (strEQ(name + 5, "SETCONTENT")) {	/* ST_RE removed */
#ifdef ST_RESETCONTENT
	    return ST_RESETCONTENT;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_R(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'A':
	if (strEQ(name + 4, "ANGENOTSATISFIABLE")) {	/* ST_R removed */
#ifdef ST_RANGENOTSATISFIABLE
	    return ST_RANGENOTSATISFIABLE;
#else
	    goto not_there;
#endif
	}
    case 'E':
	return constant_ST_RE(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_B(char *name, int len, int arg)
{
    if (4 + 2 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[4 + 2]) {
    case 'G':
	if (strEQ(name + 4, "ADGATEWAY")) {	/* ST_B removed */
#ifdef ST_BADGATEWAY
	    return ST_BADGATEWAY;
#else
	    goto not_there;
#endif
	}
    case 'R':
	if (strEQ(name + 4, "ADREQUEST")) {	/* ST_B removed */
#ifdef ST_BADREQUEST
	    return ST_BADREQUEST;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_SE(char *name, int len, int arg)
{
    switch (name[5 + 0]) {
    case 'E':
	if (strEQ(name + 5, "EOTHER")) {	/* ST_SE removed */
#ifdef ST_SEEOTHER
	    return ST_SEEOTHER;
#else
	    goto not_there;
#endif
	}
    case 'R':
	if (strEQ(name + 5, "RVICEUNAVAILABLE")) {	/* ST_SE removed */
#ifdef ST_SERVICEUNAVAILABLE
	    return ST_SERVICEUNAVAILABLE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_S(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'E':
	return constant_ST_SE(name, len, arg);
    case 'W':
	if (strEQ(name + 4, "WITCHINGPROTOCOLS")) {	/* ST_S removed */
#ifdef ST_SWITCHINGPROTOCOLS
	    return ST_SWITCHINGPROTOCOLS;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_CO(char *name, int len, int arg)
{
    if (5 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[5 + 1]) {
    case 'F':
	if (strEQ(name + 5, "NFLICT")) {	/* ST_CO removed */
#ifdef ST_CONFLICT
	    return ST_CONFLICT;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (strEQ(name + 5, "NTINUE")) {	/* ST_CO removed */
#ifdef ST_CONTINUE
	    return ST_CONTINUE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_C(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'O':
	return constant_ST_CO(name, len, arg);
    case 'R':
	if (strEQ(name + 4, "REATED")) {	/* ST_C removed */
#ifdef ST_CREATED
	    return ST_CREATED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_UNS(char *name, int len, int arg)
{
    if (6 + 8 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[6 + 8]) {
    case 'M':
	if (strEQ(name + 6, "UPPORTEDMEDIATYPE")) {	/* ST_UNS removed */
#ifdef ST_UNSUPPORTEDMEDIATYPE
	    return ST_UNSUPPORTEDMEDIATYPE;
#else
	    goto not_there;
#endif
	}
    case 'V':
	if (strEQ(name + 6, "UPPORTEDVERSION")) {	/* ST_UNS removed */
#ifdef ST_UNSUPPORTEDVERSION
	    return ST_UNSUPPORTEDVERSION;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_UN(char *name, int len, int arg)
{
    switch (name[5 + 0]) {
    case 'A':
	if (strEQ(name + 5, "AUTHORIZED")) {	/* ST_UN removed */
#ifdef ST_UNAUTHORIZED
	    return ST_UNAUTHORIZED;
#else
	    goto not_there;
#endif
	}
    case 'S':
	return constant_ST_UNS(name, len, arg);
    case 'U':
	if (strEQ(name + 5, "USED")) {	/* ST_UN removed */
#ifdef ST_UNUSED
	    return ST_UNUSED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_U(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'N':
	return constant_ST_UN(name, len, arg);
    case 'S':
	if (strEQ(name + 4, "SEPROXY")) {	/* ST_U removed */
#ifdef ST_USEPROXY
	    return ST_USEPROXY;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_F(char *name, int len, int arg)
{
    if (4 + 1 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[4 + 1]) {
    case 'R':
	if (strEQ(name + 4, "ORBIDDEN")) {	/* ST_F removed */
#ifdef ST_FORBIDDEN
	    return ST_FORBIDDEN;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 4, "OUND")) {	/* ST_F removed */
#ifdef ST_FOUND
	    return ST_FOUND;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_G(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'A':
	if (strEQ(name + 4, "ATEWAYTIMEOUT")) {	/* ST_G removed */
#ifdef ST_GATEWAYTIMEOUT
	    return ST_GATEWAYTIMEOUT;
#else
	    goto not_there;
#endif
	}
    case 'O':
	if (strEQ(name + 4, "ONE")) {	/* ST_G removed */
#ifdef ST_GONE
	    return ST_GONE;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_ST_M(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'E':
	if (strEQ(name + 4, "ETHODNOTALLOWED")) {	/* ST_M removed */
#ifdef ST_METHODNOTALLOWED
	    return ST_METHODNOTALLOWED;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 4, "ULTIPLECHOICES")) {	/* ST_M removed */
#ifdef ST_MULTIPLECHOICES
	    return ST_MULTIPLECHOICES;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_S(char *name, int len, int arg)
{
    if (1 + 2 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[1 + 2]) {
    case 'A':
	if (strEQ(name + 1, "T_ACCEPTED")) {	/* S removed */
#ifdef ST_ACCEPTED
	    return ST_ACCEPTED;
#else
	    goto not_there;
#endif
	}
    case 'B':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_B(name, len, arg);
    case 'C':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_C(name, len, arg);
    case 'E':
	if (strEQ(name + 1, "T_EXPECTATIONFAILED")) {	/* S removed */
#ifdef ST_EXPECTATIONFAILED
	    return ST_EXPECTATIONFAILED;
#else
	    goto not_there;
#endif
	}
    case 'F':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_F(name, len, arg);
    case 'G':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_G(name, len, arg);
    case 'I':
	if (strEQ(name + 1, "T_INTERNALERROR")) {	/* S removed */
#ifdef ST_INTERNALERROR
	    return ST_INTERNALERROR;
#else
	    goto not_there;
#endif
	}
    case 'L':
	if (strEQ(name + 1, "T_LENGTHREQUIRED")) {	/* S removed */
#ifdef ST_LENGTHREQUIRED
	    return ST_LENGTHREQUIRED;
#else
	    goto not_there;
#endif
	}
    case 'M':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_M(name, len, arg);
    case 'N':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_N(name, len, arg);
    case 'O':
	if (strEQ(name + 1, "T_OK")) {	/* S removed */
#ifdef ST_OK
	    return ST_OK;
#else
	    goto not_there;
#endif
	}
    case 'P':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_P(name, len, arg);
    case 'R':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_R(name, len, arg);
    case 'S':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_S(name, len, arg);
    case 'T':
	if (strEQ(name + 1, "T_TEMPORARYREDIRECT")) {	/* S removed */
#ifdef ST_TEMPORARYREDIRECT
	    return ST_TEMPORARYREDIRECT;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (!strnEQ(name + 1,"T_", 2))
	    break;
	return constant_ST_U(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_MD_P(char *name, int len, int arg)
{
    switch (name[4 + 0]) {
    case 'O':
	if (strEQ(name + 4, "OST")) {	/* MD_P removed */
#ifdef MD_POST
	    return MD_POST;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 4, "UT")) {	/* MD_P removed */
#ifdef MD_PUT
	    return MD_PUT;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_M(char *name, int len, int arg)
{
    if (1 + 2 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[1 + 2]) {
    case 'C':
	if (strEQ(name + 1, "D_CONNECT")) {	/* M removed */
#ifdef MD_CONNECT
	    return MD_CONNECT;
#else
	    goto not_there;
#endif
	}
    case 'D':
	if (strEQ(name + 1, "D_DELETE")) {	/* M removed */
#ifdef MD_DELETE
	    return MD_DELETE;
#else
	    goto not_there;
#endif
	}
    case 'G':
	if (strEQ(name + 1, "D_GET")) {	/* M removed */
#ifdef MD_GET
	    return MD_GET;
#else
	    goto not_there;
#endif
	}
    case 'H':
	if (strEQ(name + 1, "D_HEAD")) {	/* M removed */
#ifdef MD_HEAD
	    return MD_HEAD;
#else
	    goto not_there;
#endif
	}
    case 'L':
	if (strEQ(name + 1, "D_LAST")) {	/* M removed */
#ifdef MD_LAST
	    return MD_LAST;
#else
	    goto not_there;
#endif
	}
    case 'O':
	if (strEQ(name + 1, "D_OPTIONS")) {	/* M removed */
#ifdef MD_OPTIONS
	    return MD_OPTIONS;
#else
	    goto not_there;
#endif
	}
    case 'P':
	if (!strnEQ(name + 1,"D_", 2))
	    break;
	return constant_MD_P(name, len, arg);
    case 'T':
	if (strEQ(name + 1, "D_TRACE")) {	/* M removed */
#ifdef MD_TRACE
	    return MD_TRACE;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 1, "D_UNKNOWN")) {	/* M removed */
#ifdef MD_UNKNOWN
	    return MD_UNKNOWN;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant(char *name, int len, int arg)
{
    errno = 0;
    switch (name[0 + 0]) {
    case 'G':
	return constant_G(name, len, arg);
    case 'H':
	return constant_H(name, len, arg);
    case 'I':
	return constant_I(name, len, arg);
    case 'M':
	return constant_M(name, len, arg);
    case 'P':
	return constant_P(name, len, arg);
    case 'S':
	return constant_S(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


MODULE = Pi3		PACKAGE = Pi3		


double
constant(sv,arg)
    PREINIT:
	STRLEN		len;
    INPUT:
	SV *		sv
	char *		s = SvPV(sv, len);
	int		arg
    CODE:
	RETVAL = constant(s,len,arg);
    OUTPUT:
	RETVAL


int
HTTPCore_cleanupClient()

int
HTTPCore_cleanupServer()

int
HTTPCore_debugEnabled()

int
HTTPCore_dispatch(pPIHTTP, iStartPhase, iEndPhase)
	PIHTTP *	pPIHTTP
	int	iStartPhase
	int	iEndPhase

int
HTTPCore_executePhase(pPIHTTP, nextHandler, pArg)
	PIHTTP *	pPIHTTP
	PIObject *	nextHandler
	void *	pArg

PIFInfo *
HTTPCore_getCachedFile(pPath)
	char *	pPath

char *
HTTPCore_getMIMETypeFromExtension(pExtension)
	char *	pExtension

char *
HTTPCore_getServerStamp()

int
HTTPCore_initClient()

int
HTTPCore_initServer(pObject)
	PIObject *	pObject

int
HTTPCore_loadMIMEFile(pObject, pMimeDB, pMimeFile)
	PIObject *	pObject
	PIDB *	pMimeDB
	char *	pMimeFile

int
HTTPCore_logDebug(iLevel, pFormat, ...)
	int	iLevel
	char *	pFormat

int
HTTPCore_logError(pPIHTTP, pFormat, ...)
	PIHTTP *	pPIHTTP
	char *	pFormat

int
HTTPCore_readHeaders(pB, pDB, iFlags)
	PIIOBuffer *	pB
	PIDB *	pDB
	int	iFlags

int
HTTPCore_relativeToAbsolutePath(pDB, pRelative, pResult)
	PIDB *	pDB
	char *	pRelative
	Pi3String *	pResult

void
HTTPCore_releaseCachedFile(pInfo)
	PIFInfo *	pInfo

int
HTTPCore_sendEntityHeaders(pPIHTTP, pR)
	PIHTTP *	pPIHTTP
	PIDB *	pR

int
HTTPCore_sendGeneralHeaders(pPIHTTP)
	PIHTTP *	pPIHTTP

int
HTTPUtil_contractPath(pPath)
	char *	pPath

int
HTTPUtil_doHTTPError(pPIHTTP, iError)
	PIHTTP *	pPIHTTP
	int	iError

int
HTTPUtil_doHTTPRequest(pBuffer, pRequestData)
	PIIOBuffer *	pBuffer
	PIDB *	pRequestData

char *
HTTPUtil_getHostName(pPIHTTP)
	PIHTTP *	pPIHTTP

char *
HTTPUtil_getHostPort(pPIHTTP)
	PIHTTP *	pPIHTTP

int
HTTPUtil_phaseNameToNumber(pPhaseName)
	char *	pPhaseName

char *
HTTPUtil_phaseNumberToName(iPhaseNumber)
	int	iPhaseNumber

char *
HTTPUtil_protocolNumberToName(iProtocol)
	int	iProtocol

int
HTTPUtil_rFC822Time(pT, pResult)
	struct tm *	pT
	Pi3String *	pResult

int
HTTPUtil_rcNameToNumber(pName)
	char *	pName

char *
HTTPUtil_rcNumberToName(iRC)
	int	iRC

int
HTTPUtil_readTime(pLine, pT)
	char *	pLine
	struct tm *	pT

int
HTTPUtil_recvFile(pPIHTTP, pBuffer, pFInfo)
	PIHTTP *	pPIHTTP
	PIIOBuffer *	pBuffer
	PIFInfo *	pFInfo

int
HTTPUtil_recvMultipartMsg(pPIHTTP, pBuffer, cb, pUser)
	PIHTTP *	pPIHTTP
	PIIOBuffer *	pBuffer
	PFN_MUTLIPARTCB	cb
	void *	pUser

int
HTTPUtil_regexMatch(pRegex, iRegex, pString, iStringLen)
	char *	pRegex
	int	iRegex
	char *	pString
	int	iStringLen

int
HTTPUtil_regexMatchPi3String(pRegexPattern, pString)
	const Pi3String *	pRegexPattern
	const Pi3String *	pString

int
HTTPUtil_sendFile(pBuffer, pFInfo, iBufferingFlags, iSendFlags)
	PIIOBuffer *	pBuffer
	PIFInfo *	pFInfo
	int	iBufferingFlags
	int	iSendFlags

void
HTTPUtil_urlDecode(pToDecode, pResult)
	const Pi3String *	pToDecode
	Pi3String *	pResult

void
HTTPUtil_urlEncode(pToEncode, pResult)
	const Pi3String *	pToEncode
	Pi3String *	pResult

const PIDLL *
PIClass_getLibrary(pClass)
	const PIClass *	pClass

const PIClass *
PIClass_load(pDB, pConfig, pName)
	PIDB *	pDB
	PIConfig *	pConfig
	char *	pName

const PIClass *
PIClass_lookup(pDB, pName)
	PIDB *	pDB
	char *	pName

const PIClass *
PIClass_lookupOrLoad(pDB, pConfig, pClassName)
	PIDB *	pDB
	PIConfig *	pConfig
	char *	pClassName

char *
PIConfigString_getString(pString)
	PIConfigString *	pString

PIConfig *
PIConfig_findConfiguration(pDB)
	PIDB *	pDB

int
PIConfig_loadConfigurationFile(pDB, pFileName, ppConfigDB)
	PIDB *	pDB
	char *	pFileName
	PIConfig **	ppConfigDB

PIConfig *
PIConfig_lookupTree(pConfig, pKey, pInfoBuffer, iLen)
	PIConfig *	pConfig
	char *	pKey
	char *	pInfoBuffer
	int	iLen

char *
PIConfig_lookupValue(pConfig, pKey, pInfoBuffer, iLen)
	PIConfig *	pConfig
	char *	pKey
	char *	pInfoBuffer
	int	iLen

PIDB *
PIDBEx_new(pParent, pName, fnLookup)
	PIDB *	pParent
	char *	pName
	void *	fnLookup

int
PIDBIterator_atValidElement(pIter)
	PIDBIterator *	pIter

void *
PIDBIterator_current(pIter, iType, pKey)
	PIDBIterator *	pIter
	int	iType
	char *	pKey
PREINIT:
	char *	retval;
CODE:
	RETVAL = PIDBIterator_current(pIter, &pKey);
	XSprePUSH;
	sv_setpv(ST(2), (char *)pKey);

	switch (iType) {
		case PIDBTYPE_STRING:
		case PIDBTYPE_RFC822:
			retval = (char *)RETVAL;
			if (retval) {
				PUSHs(newSVpv(retval, strlen(retval)));
			} else {
				PUSHs(newSVpv("", 0));
			};
			break;
		case PIDBTYPE_TREE:
		case PIDBTYPE_USER:
		default: PUSHi(PTR2IV(RETVAL));
	}

int
PIDBIterator_delete(pIter)
	PIDBIterator *	pIter

int
PIDBIterator_next(pIter)
	PIDBIterator *	pIter

int
PIDBIterator_removeCurrent(pIter)
	PIDBIterator *	pIter

int
PIDB_add(pTree, iType, pKey, pV, iFlags)
	PIDB *	pTree
	int	iType
	char *	pKey
	void *	pV
	int	iFlags
PREINIT:
	char *	pValue = (char *)SvPV(ST(3),PL_na);
CODE:

	switch (iType) {
		case PIDBTYPE_STRING:
		case PIDBTYPE_RFC822:
			RETVAL = PIDB_add(pTree, iType, pKey, (void *)pValue, iFlags);
			break;
		case PIDBTYPE_TREE:
		case PIDBTYPE_USER:
		default: RETVAL = PIDB_add(pTree, iType, pKey, pV, iFlags);
	}
	XSprePUSH; PUSHi((IV)RETVAL);

int
PIDB_delete(pTree)
	PIDB *	pTree

char *
PIDB_getFastKey(pKey, iType)
	char *	pKey
	int	iType

PIDBIterator *
PIDB_getIterator(pTree, iType, pKey, iFlags)
	PIDB *	pTree
	int	iType
	char *	pKey
	int	iFlags
CODE:
	if (strlen(pKey)==0) pKey = 0;
	RETVAL = PIDB_getIterator(pTree, iType, pKey, iFlags);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "PIDBIteratorPtr", (void*)RETVAL);

PIDB *
PIDB_getParent(pThis)
	PIDB *	pThis

PIDB *
PIDB_getRoot(pTree)
	PIDB *	pTree

void *
PIDB_lookup(pTree, iType, pKey, iFlags)
	PIDB *	pTree
	int	iType
	char *	pKey
	int	iFlags
PREINIT:
	char *retval;
CODE:
	RETVAL = PIDB_lookup(pTree, iType, pKey, iFlags);
	XSprePUSH;
	switch (iType) {
		case PIDBTYPE_STRING:
		case PIDBTYPE_RFC822:
			retval = (char *)RETVAL;
			if (retval) {
				PUSHs(newSVpv(retval, strlen(retval)));
			} else {
				PUSHs(newSVpv("", 0));
			};
			break;
		case PIDBTYPE_TREE:
		case PIDBTYPE_USER:
		default: PUSHi(PTR2IV(RETVAL));
	}

PIDB *
PIDB_new(pParent, pName)
	PIDB *	pParent
	char *	pName

int
PIDB_pidbflagsNameToNumber(pFlags)
	char *	pFlags

int
PIDB_pidbtypeNameToNumber(pType)
	char *	pType

int
PIDB_replace(pTree, iType, pKey, pV, iFlags)
	PIDB *	pTree
	int	iType
	char *	pKey
	void *	pV
	int	iFlags
PREINIT:
	char *	pValue = (char *)SvPV(ST(3),PL_na);
CODE:
	switch (iType) {
		case PIDBTYPE_STRING:
		case PIDBTYPE_RFC822:
			RETVAL = PIDB_replace(pTree, iType, pKey, (void *)pValue, iFlags);
			break;
		case PIDBTYPE_TREE:
		case PIDBTYPE_USER:
		default: RETVAL = PIDB_replace(pTree, iType, pKey, pV, iFlags);
	}
	XSprePUSH; PUSHi((IV)RETVAL);

int
PIDLL_delete(pDLL)
	PIDLL *	pDLL

void *
PIDLL_getAddress(pDLL, pSymbolName)
	PIDLL *	pDLL
	char *	pSymbolName

char *
PIDLL_getErrorDescription(pDLL)
	const PIDLL *	pDLL

void *
PIDLL_getSystemHandle(pDLL)
	const PIDLL *	pDLL

int
PIDLL_isLoaded(pDLL)
	const PIDLL *	pDLL

PIDLL *
PIDLL_new(pPath)
	char *	pPath

int
PIFInfo_delete(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_exists(pFileInfo)
	PIFInfo *	pFileInfo

char *
PIFInfo_getAlternateName(pFileInfo)
	PIFInfo *	pFileInfo

char *
PIFInfo_getExtension(pFileInfo)
	PIFInfo *	pFileInfo

PIFInfo *
PIFInfo_getFirstFileInDirectory(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_getLastModified(pFileInfo)
	PIFInfo *	pFileInfo

char *
PIFInfo_getName(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_getNextFileInDirectory(pFileInfo)
	PIFInfo *	pFileInfo

char *
PIFInfo_getPath(pFileInfo)
	PIFInfo *	pFileInfo

char *
PIFInfo_getPathRoot(pFileInfo)
	PIFInfo *	pFileInfo

unsigned long
PIFInfo_getSize(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_isDirectory(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_isExecutable(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_isLink(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_isReadable(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_isRegular(pFileInfo)
	PIFInfo *	pFileInfo

int
PIFInfo_isWritable(pFileInfo)
	PIFInfo *	pFileInfo

PIFInfo *
PIFInfo_new(pPath)
	char *	pPath

int
PIFMap_delete(pMappedFile)
	PIFMap *	pMappedFile

void *
PIFMap_lock(pMappedFile, piLength)
	PIFMap *	pMappedFile
	int *	piLength

PIFMap *
PIFMap_new(pFileInfo)
	const PIFInfo *	pFileInfo

int
PIFMap_unlock(pMappedFile)
	PIFMap *	pMappedFile

int
PIFile_close(tFD)
	int	tFD

int
PIFile_open(pPath, pFlags)
	char *	pPath
	char *	pFlags

int
PIFile_read(tFD, iLength, pData)
	int	tFD
	int	iLength
	void *	pData

int
PIFile_unlink(pPath)
	char *	pPath

int
PIFile_write(tFD, iLength, pData)
	int	tFD
	int	iLength
	const void *	pData

int
PIFile_writeAtomic(tFD, iLength, pData)
	int	tFD
	int	iLength
	const void *	pData

void *
PIHTTP_allocMem(pPIHTTP, iSize)
	PIHTTP *	pPIHTTP
	unsigned int	iSize

int
PIHTTP_delete(pPIHTTP)
	PIHTTP *	pPIHTTP

PIDB *
PIHTTP_getDB(pPIHTTP, iType)
	PIHTTP *	pPIHTTP
	int	iType

int
PIHTTP_isChild(pPIHTTP)
	PIHTTP *	pPIHTTP

PIHTTP *
PIHTTP_new(pIOObject, pHostDB)
	PIObject *	pIOObject
	PIDB *	pHostDB

PIHTTP *
PIHTTP_newChild(pParent)
	PIHTTP *	pParent

int
PIIOBuffer_advanceBufferPointer(pIOBuf, iCount)
	PIIOBuffer *	pIOBuf
	int	iCount

int
PIIOBuffer_delete(pPIIOBuffer)
	PIIOBuffer *	pPIIOBuffer

int
PIIOBuffer_flush(pIOBuf)
	PIIOBuffer *	pIOBuf

int
PIIOBuffer_getBufferLen(pIOBuf)
	PIIOBuffer *	pIOBuf

int
PIIOBuffer_getBytesSent(pIOBuf)
	PIIOBuffer *	pIOBuf

int
PIIOBuffer_getLine(pIOBuf, pszBuf, iBufLen)
	PIIOBuffer *	pIOBuf
	char *	pszBuf
	int	iBufLen

int
PIIOBuffer_getOutputBuffer(pIOBuf, ppBuffer)
	PIIOBuffer *	pIOBuf
	char **	ppBuffer

void *
PIIOBuffer_getUserData(pIOBuf)
	PIIOBuffer *	pIOBuf

PIIOBuffer *
PIIOBuffer_new(pIOObject)
	PIObject *	pIOObject

int
PIIOBuffer_pollBeforeRead(pIOBuf)
	PIIOBuffer *	pIOBuf

char *
PIIOBuffer_read(pIOBuf, piRead)
	PIIOBuffer *	pIOBuf
	int *	piRead

int
PIIOBuffer_readToBuffer(pIOBuf, pszBuf, iMaxLen)
	PIIOBuffer *	pIOBuf
	char *	pszBuf
	int	iMaxLen

void
PIIOBuffer_resetBytesSent(pIOBuf)
	PIIOBuffer *	pIOBuf

void
PIIOBuffer_setUserData(pIOBuf, pUserData)
	PIIOBuffer *	pIOBuf
	void *	pUserData

int
PIIOBuffer_write(pIOBuf, pszBuf, iLen, iFlags)
	PIIOBuffer *	pIOBuf
	char *	pszBuf
	int	iLen
	int	iFlags

int
PIIOBuffer_writeLn(pIOBuf, pszBuf, iLen, iFlags)
	PIIOBuffer *	pIOBuf
	char *	pszBuf
	int	iLen
	int	iFlags

int
PIIO_in(pObj, pData, iLen, piReceived, iArgc, ppArgv)
	PIObject *	pObj
	void *	pData
	int	iLen
	int *	piReceived
	int	iArgc
	char **	ppArgv

int
PIIO_out(pObj, pData, iLen, piSent, iArgc, ppArgv)
	PIObject *	pObj
	void *	pData
	int	iLen
	int *	piSent
	int	iArgc
	char **	ppArgv

const PILibrary *
PILibrary_load(pDB, pConfig, pLibraryName)
	PIDB *	pDB
	PIConfig *	pConfig
	char *	pLibraryName

const PILibrary *
PILibrary_lookup(pDB, pLibrary)
	PIDB *	pDB
	char *	pLibrary

const PILibrary *
PILibrary_lookupOrLoad(pDB, pConfig, pLibraryName)
	PIDB *	pDB
	PIConfig *	pConfig
	char *	pLibraryName

int
PILog_addMessage(pDB, pConfig, iType, pFormat, ...)
	PIDB *	pDB
	PIConfig *	pConfig
	int	iType
	char *	pFormat

int
PILog_newSink(iType, pParam)
	int	iType
	char *	pParam

int
PILog_writeDiagnostics(pDB, iFlags, pFileName)
	PIDB *	pDB
	int	iFlags
	char *	pFileName

int
PILogic_execute(pObj, iArgc, ppArgv)
	PIObject *	pObj
	int	iArgc
	char **	ppArgv

PIObject *
PIObject_copy(pObject, iArgc, ppArgv)
	const PIObject *	pObject
	int	iArgc
	char **	ppArgv

int
PIObject_delete(pObj, iArgc, ppArgv)
	PIObject *	pObj
	int	iArgc
	char **	ppArgv

const PIClass *
PIObject_getClass(pObj)
	const PIObject *	pObj

PIConfig *
PIObject_getConfigurationDB(pObj)
	const PIObject *	pObj

PIDB *
PIObject_getDB(pObj)
	const PIObject *	pObj

char *
PIObject_getName(pObj)
	const PIObject *	pObj

void *
PIObject_getUserData(pObj)
	const PIObject *	pObj

PIObject *
PIObject_load(pDB, pConfig, pName, iArgc, ppArgv)
	PIDB *	pDB
	PIConfig *	pConfig
	char *	pName
	int	iArgc
	char **	ppArgv

PIObject *
PIObject_loadEx(pParent, pObjectKey)
	const PIObject *	pParent
	char *	pObjectKey

PIObject *
PIObject_loadFromLine(pDB, pConfig, pObjectLine)
	PIDB *	pDB
	PIConfig *	pConfig
	char *	pObjectLine

PIObject *
PIObject_new(pClass, pDB, pConfig, pName, iArgc, ppArgv)
	const PIClass *	pClass
	PIDB *	pDB
	PIConfig *	pConfig
	char *	pName
	int	iArgc
	char **	ppArgv

int
PIObject_readParameters(pParent, iArgc, ppArgv, fnParameters, pParam)
	PIObject *	pParent
	int	iArgc
	char **	ppArgv
	int *	fnParameters
	void *	pParam

int
PIObject_setConfigurationDB(pObj, pConfig)
	PIObject *	pObj
	PIConfig *	pConfig

int
PIObject_setDB(pObj, pDB)
	PIObject *	pObj
	PIDB *	pDB

int
PIObject_setUserData(pObj, pData)
	PIObject *	pObj
	void *	pData

int
PIPlatform_advisaryLockFd(tFD)
	int	tFD

int
PIPlatform_advisaryUnlockFd(tFD)
	int	tFD

int
PIPlatform_afterUnsafeBlock()

PISync *
PIPlatform_allocLocalMutex()

PISync *
PIPlatform_allocLocalSemaphore(iInitialCount, iMaxCount)
	int	iInitialCount
	int	iMaxCount

int
PIPlatform_beforeUnsafeBlock()

void
PIPlatform_catchExceptions(arg0, arg1)
	void ( * ) ( void * )	arg0
	void *	arg1

int
PIPlatform_enter(pArgv0, iVersion, fn)
	char *	pArgv0
	int	iVersion
	PIPlatformFn	fn

int
PIPlatform_getCurrentDirectory(pBuffer, iMaxLen)
	char *	pBuffer
	int	iMaxLen

char *
PIPlatform_getDescription()

char
PIPlatform_getDirectorySeparator()

int
PIPlatform_getLastError()

int
PIPlatform_getProcess()

int
PIPlatform_getProcessId()

int
PIPlatform_getUniqueId(szBuf, iLen)
	char *	szBuf
	unsigned int	iLen

int
PIPlatform_pollFD(fd, iFlags, iTimeout)
	int	fd
	int	iFlags
	int	iTimeout

int
PIPlatform_pollNetFD(fdSocket, iFlags, iTimeout)
	int	fdSocket
	int	iFlags
	int	iTimeout

int
PIPlatform_pollPipeFD(fd, iFlags, iTimeout)
	int	fd
	int	iFlags
	int	iTimeout

void
PIPlatform_setLastError(iErrorCode)
	int	iErrorCode

int
PIPlatform_sleep(iMilliseconds)
	int	iMilliseconds

int
PIPlatform_waitForProcess(tProcess, iFlags, iTimeout)
	int	tProcess
	int	iFlags
	int	iTimeout

int
PIProgram_dbgDump(pDB, pDumpFile)
	PIDB *	pDB
	char *	pDumpFile

int
PIProgram_enter(pProgramName, iVersion, fn)
	char *	pProgramName
	int	iVersion
	PIProgramFn	fn

int
PISync_delete(pSync)
	PISync *	pSync

int
PISync_lock(pSync)
	PISync *	pSync

int
PISync_tryLock(pSync)
	PISync *	pSync

int
PISync_unlock(pSync)
	PISync *	pSync

int
PIThread_begin(pThread, fnEntry, ulData, iPriority, iFlags)
	PIThread *	pThread
	PIThreadFn	fnEntry
	unsigned long	ulData
	int	iPriority
	int	iFlags

void
PIThread_dbgDump(pDbgDump)
	char *	pDbgDump

int
PIThread_delete(pThread)
	PIThread *	pThread

int
PIThread_destroyThreadKey(iKey)
	int	iKey

PIThread *
PIThread_getCurrent()

void *
PIThread_getData(pThread, iKey)
	PIThread *	pThread
	int	iKey

PIThread *
PIThread_getMain()

int
PIThread_getPriority(pThread, piPriority)
	PIThread *	pThread
	int *	piPriority

void *
PIThread_getSystemHandle(pThread)
	PIThread *	pThread

int
PIThread_initThreadKey()

PIThread *
PIThread_new(pPool, iStackSize)
	PIMemoryPool *	pPool
	int	iStackSize

int
PIThread_resume(pThread)
	PIThread *	pThread

int
PIThread_setData(pThread, iKey, pData)
	PIThread *	pThread
	int	iKey
	void *	pData

int
PIThread_setPriority(pThread, iNewPriority)
	PIThread *	pThread
	int	iNewPriority

int
PIThread_suspend(pThread)
	PIThread *	pThread

int
PIThread_terminate(pThread, ulExitCode)
	PIThread *	pThread
	unsigned long	ulExitCode

int
PIThread_userYield()

int
PIThread_waitForThread(pThread)
	PIThread *	pThread

int
PIThread_yield()

int
PITimer_delete(pTimer)
	PITimer *	pTimer

int
PITimer_elapsed(pTimer, plSeconds, plMicroSeconds)
	PITimer *	pTimer
	long *	plSeconds
	long *	plMicroSeconds

PITimer *
PITimer_new()

int
PITimer_reset(pTimer)
	PITimer *	pTimer

void *
PIUserType_getValue(pUserType)
	PIUserType *	pUserType

void
PIUtil_free(pV)
	void *	pV

void *
PIUtil_malloc(ulData)
	unsigned long	ulData

char *
PIUtil_strdup(pS)
	char *	pS

int
PIUtil_stricmp(pS1, pS2)
	char *	pS1
	char *	pS2

int
PIUtil_strncmpi(pS1, pS2, iLen)
	char *	pS1
	char *	pS2
	int	iLen

int
Pi3Expression_delete(pExpr)
	Pi3Expression *	pExpr

Pi3Expression *
Pi3Expression_new(pExpression, pParameters, pErrorDescription)
	char *	pExpression
	FnPi3Write *	pParameters
	Pi3String *	pErrorDescription

int
Pi3Expression_write(pExpression, pPIHTTP, pData, pBuffer, iBufferLength)
	Pi3Expression *	pExpression
	PIHTTP *	pPIHTTP
	void *	pData
	char *	pBuffer
	int	iBufferLength

int
Pi3String_delete(pString)
	Pi3String *	pString

int
Pi3String_getLength(pString)
	const Pi3String *	pString

char *
Pi3String_getPtr(pString)
	const Pi3String *	pString

Pi3String *
Pi3String_new(pString)
	char *	pString

Pi3String *
Pi3String_newEx(pString, iLength)
	char *	pString
	int	iLength
