/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    and Holger Zimmermann (http://pi3web.sourceforge.net/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/PiAPI/_PIFile.cpp,v $
 * $Date: 2001/04/07 13:30:22 $
 *
 Description:
\*____________________________________________________________________________*/
//$SourceTop:$

#include "PiAPI.h"
#include "Platform.h"
#include "PlatDefs.h"

/*____________________________________________________________________________*\
*
 Description:
    See API header files in ../PIAPI for full description
\*____________________________________________________________________________*/
PUBLIC_PIAPI PIPLATFORM_FD PIFile_open( const char *pPath, const char *pFlags )
{
	if ( !pPath )
		{ PIERROR( PIAPI_EINVAL ); return PIPLATFORM_FD_INVALID; };
	return Platform::Open( pPath, pFlags );
}

/*____________________________________________________________________________*\
 *
 Description:
	See API header files in ../PIAPI for full description
\*____________________________________________________________________________*/
PUBLIC_PIAPI int PIFile_close( PIPLATFORM_FD tFD )
{
	if ( tFD==PIPLATFORM_FD_INVALID )
		{ PIERROR( PIAPI_EINVAL ); return PIAPI_ERROR; };
	return Platform::Close( tFD );
}

/*____________________________________________________________________________*\
*
 Description:
    See API header files in ../PIAPI for full description
\*____________________________________________________________________________*/
PUBLIC_PIAPI int PIFile_unlink( const char *pPath )
{
	if ( !pPath )
		{ PIERROR( PIAPI_EINVAL ); return PIPLATFORM_FD_INVALID; };
	return Platform::Unlink( pPath );
}

/*____________________________________________________________________________*\
 *
 Description:
	See API header files in ../PIAPI for full description
\*____________________________________________________________________________*/
PUBLIC_PIAPI int PIFile_read( PIPLATFORM_FD tFD, int iMaxLen,
	void *pData )
{
	if ( !pData || !iMaxLen )
		{ PIERROR( PIAPI_EINVAL ); return PIAPI_ERROR; };
	return Platform::Read( tFD, iMaxLen, pData );
}

/*____________________________________________________________________________*\
 *
 Description:
	See API header files in ../PIAPI for full description
\*____________________________________________________________________________*/
PUBLIC_PIAPI int PIFile_write( PIPLATFORM_FD tFD, int iMaxLen,
	const void *pData )
{
	if ( !pData || !iMaxLen )
		{ PIERROR( PIAPI_EINVAL ); return PIAPI_ERROR; };
	return Platform::Write( tFD, iMaxLen, pData );
}

/*____________________________________________________________________________*\
 *
 Description:
	See API header files in ../PIAPI for full description
\*____________________________________________________________________________*/
PUBLIC_PIAPI int PIFile_writeAtomic( PIPLATFORM_FD tFD, int iMaxLen,
	const void *pData )
{
	if ( !pData || !iMaxLen )
		{ PIERROR( PIAPI_EINVAL ); return PIAPI_ERROR; };
	return Platform::WriteAtomic( tFD, iMaxLen, pData );
}

