#!/usr/bin/perl

#*____________________________________________________________________________*\
#*
#
# Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.
#
# These sources, libraries and applications are
# FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
# as long as the following conditions are adhered to.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. Redistributions of any form whatsoever and all advertising materials 
#    mentioning features must contain the following
#    acknowledgment:
#    "This product includes software developed by John Roy
#    and Holger Zimmermann (http://pi3web.sourceforge.net/)."
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
# GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
#*____________________________________________________________________________*|
#*
#* $Source: /cvsroot/pi3web/Pi3Web_200/Source/Scripts/apisyms.pl,v $
#* $Date: 2001/04/07 13:30:22 $
#*
# Description:
# ARGV[0], the path to the directories with the files	(LATER), ignored now '.'
# ARGV[1], the name of the source file to create
# ARGV[2], name of pointer to list of functions
# ARGV[3], name of header file the generated source file includes
#*____________________________________________________________________________*/

#/*___________________________________________________________________________*\
# Global declarations:
#\*___________________________________________________________________________*/
%symbols;

&do_main();

#/*___________________________________________________________________________*\
# *
# Function:
# Synopsis:
# Description:
#\*___________________________________________________________________________*/
sub do_main
	{
	local( $file );
#	$path = $ARGV[0];
	@files = <*.h *.c *.cpp>;
	foreach $file ( @files )
		{
		open( INP, '<'.$file ) || die "Cannot open file $file: $!\n";
		&process_file();
		close( INP );
		};
	open( OUT, '>'.$ARGV[1] ) || die "Cannot open file $ARGV[1]: $!\n";
	print OUT '/*____________________________________________________________________________*\
 *
	*** AUTOMATICALLY GENERATED FILE: DO NOT MODIFY ***
\*____________________________________________________________________________*/
/* $SourceTop:$ */

';
	if ( length( $ARGV[3] )>0 )
		{ print OUT "#include \"$ARGV[3]\"\n"; };
	print OUT '

/* --- functions have "C" linkage --- */
#if defined(__cplusplus)
#	define __PIAPI extern "C"
#else
#	define __PIAPI extern
#endif

';
	foreach $sym ( sort( keys( %symbols ) ) )
		{ print OUT "__PIAPI void $sym(void);\n"; };
	print OUT '

/*____________________________________________________________________________*\
 *
 Global declarations:
\*____________________________________________________________________________*/
typedef void (* Fn)(void);
struct FunctionRecord{
    const char *pName;
    Fn pFunction;
};
struct FunctionRecord ';
	print OUT "tag".$ARGV[2].'[]=
{
';
	foreach $sym ( sort( keys( %symbols ) ) )
		{ print OUT "\t{ \"$sym\", $sym },\n"; };
	print OUT "\t{ 0, 0 }\n".'};

void *';
	print OUT $ARGV[2]."=(void *)&tag".$ARGV[2].";\n\n";
	};

#/*___________________________________________________________________________*\
# *
# Function:
# Synopsis:
# Description:
#\*___________________________________________________________________________*/
sub process_file
	{
	while( <INP> )
		{
		if ( /^PUBLIC_PIAPI / )
			{
			s/(.*)\(.*$/$1/;
			s/(.*)(\s|\*)(.*\w).*\n/$3/;
			$symbols{$_} = "foo";
			};
		};
	};

