
/*
 * Step 4: Initialize the program database functionality and
 * write a simple hello world.
 */

#include <iostream.h>
#include <stdlib.h>

#include "Pi2API.h"

/* ---
--- */
const char *pFile = "./Step5.cnf";

int iRet;
void Step5( PIDB *pDB )
{
	cout << "Program running on " << PIPlatform_getDescription() << endl;
	cout << endl;
	cout << "Attempting to load configuration file: '" << pFile << "'" 
		<< endl;
	if ( PIConfig_loadConfigurationFile( pDB, pFile, 0 ) )
		{
		cout << "Load failed!." << endl;
		}
	else
		{
		cout << "Load succeeded" << endl;
		};
	cout << "Dumping the program DB:-" << endl;
	PIProgram_dbgDump( pDB, 0 );
	cout << "Done" << endl;
	iRet = 0;
}

/* ---
--- */
int main()
{
	if ( PIProgram_enter( "dummy", PIPROGRAM_VERSION_1_0, Step5 ) )
		{
		cerr << "Program_enter() failed." << endl;
		exit( 1 );
		};

	return iRet;
}

